#include <iostream>

#include "SenseHandler.h"
#include "ActionScheduler.h"
#include "WorldModel.h"

using namespace std;

//struct scheduled_action {
//	int cycle; 
//	void (*action_callback)(WorldModel*,ServerSettings*,PlayerSettings*, void*, int); 
//	void* params; 
//	void (*cleanup_callback)(void*, int);
//};

ActionScheduler *as;
int a1_dispatched;
int a1_cleanedup;

void action_callback1(WorldModel* wm, ServerSettings* ss, PlayerSettings* ps, void* params, int params_size) {
	LOG_PRINT(LOG_DEBUG, "Executing action_callback");
	a1_dispatched = 0;	
}

void cleanup_callback1(void* params, int params_size) {
	LOG_PRINT(LOG_DEBUG, "Executing cleanup_callback");
	a1_cleanedup = 0;
}

void setup() {
	a1_dispatched = -1;
	a1_cleanedup = -1;
	as = new ActionScheduler(NULL, NULL, NULL);
}

void cleanup() {
	if(as != NULL)
		delete as;
}

int testScheduleAction() {
	as->scheduleAction(3, &action_callback1, &cleanup_callback1, NULL, 0);
	as->dispatchAction(3);
	if(a1_dispatched != 0)
		return -1;
	
	a1_dispatched = -1;
	as->dispatchAction(3);
	if(a1_dispatched == 0)
		return -1;
		
	return 0;
}

int testCleanupAction() {
	as->scheduleAction(3, &action_callback1, &cleanup_callback1, NULL, 0);
	as->dispatchAction(3);
	if(a1_cleanedup != 0) 
		return -1;
	
	a1_cleanedup = -1;
	as->dispatchAction(3);
	if(a1_cleanedup == 0)
		return -1;
		
	return 0;
}

int test1() {
	as->scheduleAction(3, &action_callback1, &cleanup_callback1, NULL, 0);
}

int main( int argc, char* argv[] ) {
	Log.addLogRange(0,1500);
	
	cout << "TEST RUN" << endl << "===========" << endl; 
	setup(); 
	int t_scheduleActionRes = testScheduleAction();
	cleanup();
	
	cout << "TEST RUN" << endl << "===========" << endl;
	setup(); 
	int t_cleanupActionRes = testCleanupAction();
	cleanup();
	
	
	cout << endl;
	cout << "RESULTS" << endl;
	cout << "================" << endl;
	cout << "testScheduleAction : " << (t_scheduleActionRes == 0 ? "OK" : "FAILED") << endl;
	cout << "testCleanupAction : " << (t_cleanupActionRes == 0 ? "OK" : "FAILED") << endl;
	return 0;
}
